/* This program will generate data by summing two sinusoids the frequencies of which will be determined by user input of keypad values */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>

#define PI 3.14159265359
#define F1D 100.0
#define F2D 200.0

main(int argc,char *argv[])
{  char fname[30],nput[80];
   int i,n,handle,samples,digdur;
   double amp;
   double  f1, f2, fs, xn,a1,a2;
   short int data;
   FILE *out_file;
   

   if (argc<5)
     {
       printf("\n\nUSAGE: diggens2.exe  output_file  digit_duration  key_sequence amplitude(db)\n\n");
       exit(-1);
     }

   strcpy(fname,argv[1]);
   digdur=atoi(argv[2]);
   strcpy(nput,argv[3]);
   amp=atof(argv[4]);
   
   out_file=fopen(fname,"wb");
   if( out_file == 0 )
     { printf("\rCannot open %s.   Program Terminating\n",fname);
       exit(-1);
     }
   i=0;
   printf("\n\nWorking.....");
   printf("%s",nput);
   while (nput[i] != NULL)
     {
       switch (nput[i])
	 {
	 case '1':
	   f1 = 697;
	   f2 = 1209;
	   break;
	 case '2':
	   f1 = 697;
	   f2 = 1336;
	   break;
	 case '3':
	   f1 = 697;
	   f2 = 1477;
	   break;
	 case 'A':
	 case 'a':
	   f1 = 697;
	   f2 = 1633;
	   break;
	 case '4':
	   f1 = 770;
	   f2 = 1209;
	   break;
	 case '5':
	   f1 = 770;
	   f2 = 1336;
	   break;
	 case '6':
	   f1 = 770;
	   f2 = 1477;
	   break;
	 case 'B':
	 case 'b':
	   f1 = 770;
	   f2 = 1633;
	   break;
	 case '7':
	   f1 = 852;
	   f2 = 1209;
	   break;
	 case '8':
	   f1 = 852;
	   f2 = 1336;
	   break;
	 case '9':
	   f1 = 852;
	   f2 = 1477;
	   break;
	 case 'C':
	 case 'c':
	   f1 = 852;
	   f2 = 1633;
	   break;
	 case '*':
	   f1 = 941;
	   f2 = 1209;
	   break;
	 case '0':
	   f1 = 941;
	   f2 = 1336;
	   break;
	 case '#':
	   f1 = 941;
	   f2 = 1477;
	   break;
	 case 'D':
	 case 'd':
	   f1 = 941;
	   f2 = 1633;
	   break;
	 default:
	   f1 = F1D;
	   f2 = F2D;
	   break;
	 } 
       fs=8000;

     
       if(nput[i] == '.') 
	 {
	   samples = 0.5 * fs * digdur * 0.001;
	   a1 = 0.0;
	   a2 = 0.0;
	 }
       else 
	 {
	   samples = fs * digdur * .001;
	   a1=pow((double)10.0,(double)(amp/10.0));
	  
	   a2=a1;
	 }
       for(n=0;n<samples;n++)
	 {
	   xn = a1*cos(2.0*PI*f1*(double)n*(1.0/fs))+ a2*cos(2.0*PI*f2*(double)n*(1.0/fs));
	   data = (short int)(xn*25000);
	   if(fwrite(&data,2,1,out_file) != 1)
	     {
	       printf("\nERROR: Cannot write to file %s",fname);
	       fclose(out_file);
	       exit(-1);
	     }
	 }
       i++;
     }
   printf("\n%lf",a1);
   fclose(out_file);
   printf("\n\nDone.");

 }
