/*  This program will add noise to a dtmf file with some signal */
/*  to noise ratio. */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>

#define PI 3.14159265359
#define F1D 680
#define F2D 1240

main(int argc,char *argv[])
{  char dtmf_file[30],noise_file[30],o_file[30];
   int i,n,count;
   unsigned long N_noise,N_dtmf;
   double dtmf_sum,noise_sum;
   double snr_dif,snr_in,current_snr,scale;
   double  Pnoise,Pdtmf;
   short int dtmf_sample,noise_dtmf,test;
   short int noise_sample;
   FILE *out_file,*out_file2,*in_dtmf,*in_noise;
   
   /* Get filenames and signal to noise ratio. */
   
   if(argc<3)
     {
      printf("\nUSAGE: dtmf_file  noise_file  output_file  desired_snr\n"); 
      exit(-1);
     }

   strcpy(dtmf_file,argv[1]);
   strcpy(noise_file,argv[2]);
   strcpy(o_file,argv[3]);
   snr_in=atof(argv[4]);

  
   /* Open all needed files. */
   
   out_file = fopen(o_file,"wb");
   out_file2 = fopen("test.snr","w");
   if( out_file == 0 )
     { printf("\rCannot open %s.   Program Terminating\n",o_file);
       exit(-1);
     }
   in_dtmf=fopen(dtmf_file,"rb");
   if( in_dtmf == 0 )
     { printf("\rCannot open %s.  Program Terminating\n",dtmf_file);
       exit(-1);
     }
   in_noise = fopen(noise_file,"rb");
   if( in_noise == 0 )
     { printf("\rCannot open %s.  Program Terminating\n",noise_file);
       exit(-1);
     }
   
   noise_sum=0;
   dtmf_sum=0;
   N_noise=0;
   N_dtmf=0;
   i=0;
   n=1;
   
   /*  Read in all values from dtmf files and find current snr */
   
   while((fread(&dtmf_sample,2,1,in_dtmf)==1))
     {
       dtmf_sum += (double)((double)dtmf_sample*(double)dtmf_sample);
       N_dtmf++;
     }
   N_noise=N_dtmf;

   /* Read in Same number of values from noise file */
   for(i=0;i<N_noise;i++)
     {
       fread(&noise_sample,2,1,in_noise);
       noise_sample/=10.0;
       noise_sum += (double)((double)noise_sample*(double)noise_sample);
     }

   /*Calculate power and current SNR*/
   
   Pnoise = (1.0/N_noise)*noise_sum;
   Pdtmf = (1.0/N_dtmf)*dtmf_sum;
   current_snr=10.0*log10(Pdtmf/Pnoise);
   rewind(in_dtmf);
   rewind(in_noise);
   
   /*Calculate value to scale dtmf file by to get desired SNR*/
   /*then scale dtmf file and write dtmf+noise out to file*/

   snr_dif=current_snr-snr_in;
   scale = (dtmf_sum/noise_sum)/pow(10.0,(snr_in/10.0));
   scale=pow((double)10.0,(snr_dif/(double)10));
   scale=sqrt(scale);
   noise_sum = 0;
   for(n=0;n<N_dtmf;n++)
     {
       fread(&dtmf_sample,2,1,in_dtmf);
       fread(&noise_sample,2,1,in_noise);
       noise_sample/=10.0;
       noise_dtmf=(short int)(dtmf_sample+(noise_sample*scale));
       noise_sum += (double)((double)noise_sample*(double)noise_sample*scale*scale);
       
       fwrite(&noise_dtmf,2,1,out_file);
       fprintf(out_file2,"%i\n",noise_dtmf);
     }
   current_snr = 10.0*log10(dtmf_sum/noise_sum);
   fclose(in_noise);
   fclose(in_dtmf);
   fclose(out_file);
   fclose(out_file2);
 }
















